/****************************************************************
 AlphabetMap.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_AlphabetMap_H
#define INCL_AlphabetMap_H
#include <iostream>
#include "Alphabet.H"
#include "Array1D.H"
using namespace std;

namespace BOOM {

class AlphabetMap
{
public:
  AlphabetMap() {}
  AlphabetMap(Alphabet &domain,Alphabet &range);
  AlphabetMap(int domainSize,int rangeSize);
  AlphabetMap(const AlphabetMap &);
  Symbol operator()(Symbol a) const {return map(a);}
  Symbol map(Symbol) const;
  Symbol unmap(Symbol) const;
  void defineMapping(Symbol from,Symbol to);
  void defineInverse(Symbol from,Symbol to);
  int getDomainSize() const;
  int getRangeSize() const;
private:
  Array1D<Symbol> theMap, inverseMap;
};



class AlphabetIdentityMap : public AlphabetMap
{
public:
  AlphabetIdentityMap(Alphabet &);
};



class DropNMapping : public AlphabetMap
{
public:
  DropNMapping();
  static const DropNMapping global;
};

}

#endif

