/***********************************************************************
 Chi2IndepTest.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_Chi2IndepTest_H
#define INCL_BOOM_Chi2IndepTest_H
using namespace std;
#include "Array2D.H"
#include "Chi2Table.H"

namespace BOOM {
class Chi2IndepTest
{
public:
  Chi2IndepTest(BOOM::Array2D<int> &contingencyTable,
		BOOM::Chi2Table &);
  bool areIndependent();
  double getChiSquared();
  double getP();
  inline bool areDependent() {return !areIndependent();}
private:
  double P, chiSquared;
  bool independent;
  void runTest(BOOM::Array2D<int> &,BOOM::Chi2Table &);
};
}

#endif
