/***********************************************************************
 ComplexNum.C
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#include <iostream>
#include <math.h>
#include "ComplexNum.H"
using namespace std;



BOOM::ComplexNum::ComplexNum(double real=0.0,double imag=0.0)
  : real(real), imag(imag)
{
   
}



BOOM::ComplexNum BOOM::ComplexNum::operator+(const BOOM::ComplexNum &other)
{
  return BOOM::ComplexNum(real+other.real,imag+other.imag);
}



BOOM::ComplexNum BOOM::ComplexNum::operator*(const BOOM::ComplexNum &other)
{
  double a=real, b=imag, c=other.real, d=other.imag;
  return BOOM::ComplexNum(a*c-b*d,a*d+c*b);
}



BOOM::ComplexNum BOOM::ComplexNum::getConjugate()
{
  return BOOM::ComplexNum(real,-imag);
}



double &BOOM::ComplexNum::getImag()
{
  return imag;
}



double &BOOM::ComplexNum::getReal()
{
  return real;
}



double BOOM::ComplexNum::getImag() const
{
  return imag;
}



double BOOM::ComplexNum::getModulus() const
{
  return sqrt(real*real + imag*imag);
}



double BOOM::ComplexNum::getReal() const
{
  return real;
}
