/****************************************************************
 Correlation.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Correlation_H
#define INCL_Correlation_H
#include <iostream>
#include <utility>
#include "Vector.H"
using namespace std;


namespace BOOM {

typedef pair<double,double> DblPoint;
typedef BOOM::Vector<DblPoint> DblPointVector;

class Correlation
{
public:
  Correlation(const DblPointVector &);
  Correlation(const Vector<float> &,const Vector<float> &);
  Correlation(const Vector<double> &,const Vector<double> &);
  double getR();
  bool isSignificant(double alpha);
  double getP(); // left-tailed cumulative pdf value
private:
  double r;
  int n;

  void computeR(double sumX,double sumXX,double sumY,double sumYY,
		double sumXY);
};

}

#endif

