/***********************************************************************
 Exceptions.C
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#include <iostream>
#include "Exceptions.H"
using namespace std;
using namespace BOOM;


ArrayIndexException::ArrayIndexException(long index,
					       const BOOM::String &msg)
  : RootException("")
{
   

  installMessage(index,msg);
}



RootException::RootException(const BOOM::String &s)
  : message(s)
{
   
}



RootException::RootException(const char *cp)
  : message(cp)
{
   
}



const BOOM::String &RootException::getMessage() const
{
  return message;
}



void ArrayIndexException::installMessage(long index,const BOOM::String &msg)
{
  message=BOOM::String("Invalid index (")+index+") "+msg;
}
