/***********************************************************************
 Exceptions.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_Exceptions_H
#define INCL_BOOM_Exceptions_H
#include "String.H"
using namespace std;

namespace BOOM {
class RootException
{
public:
  RootException(const char *);
  RootException(const BOOM::String &);
  const BOOM::String &getMessage() const;
protected:
  BOOM::String message;
};

class FileErrorException : public RootException
{
public:
  FileErrorException(BOOM::String filename,BOOM::String msg)
    : RootException(filename+" "+msg) {}
};

class ArrayIndexException : public RootException
{
public:
  ArrayIndexException(long index,const BOOM::String &msg);
private:
  void installMessage(long index,const BOOM::String &);
};
}

#endif
