/***********************************************************************
 FastaWriter.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_FastaWriter_H
#define INCL_BOOM_FastaWriter_H
#include "String.H"
#include <iostream>
#include "Regex.H"
using namespace std;

namespace BOOM {
class FastaWriter
{
public:
  FastaWriter(int width=60);
  void writeFasta(const BOOM::String &defline,const BOOM::String &sequence,
		  const BOOM::String &filename);
  void writeFastaFromCharPtr(const BOOM::String &defline,
			     const char *sequence,
			 const BOOM::String &filename);
  void addToFasta(const BOOM::String &defline,const char *sequence,
		  ostream &);
  void addToFasta(const BOOM::String &defline,const BOOM::String &sequence,
		  ostream &);
private:
  int width;
  BOOM::Regex newline, greater;
};
}


#endif
