/****************************************************************
 ContinuousDistribution.H
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_ContinuousDistribution_H
#define INCL_ContinuousDistribution_H
#include <iostream>
using namespace std;



namespace GSL {

class ContinuousDistribution
{
public:
    virtual double random()=0;
    virtual double probabilityEquals(double value)=0;
    virtual double probabilityLessThan(double value)=0;
    virtual double probabilityGreaterThan(double value)=0;
    virtual double criticalValueLessThan(double P)=0;
    virtual double criticalValueGreaterThan(double P)=0;
};

}
#endif

