/****************************************************************
 GaussianDistribution.H
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_GaussianDistribution_H
#define INCL_GaussianDistribution_H
#include <iostream>
#include "ContinuousDistribution.H"
using namespace std;


namespace GSL {

class GaussianDistribution : public GSL::ContinuousDistribution
{
public:
    GaussianDistribution(double mean,double standardDeviation);
    virtual double random();
    virtual double probabilityEquals(double value);
    virtual double probabilityLessThan(double value);
    virtual double probabilityGreaterThan(double value);
    virtual double criticalValueLessThan(double P);
    virtual double criticalValueGreaterThan(double P);
private:
    double mean, SD;
};


}
#endif

