/****************************************************************
 LabeledMatrixLoader.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_LabeledMatrixLoader_H
#define INCL_LabeledMatrixLoader_H
#include <iostream>
#include "Matrix.H"
#include "../AlphabetMap.H"
#include "../String.H"
#include "../Regex.H"
using namespace std;
using namespace BOOM;


namespace GSL {
#define INVALID_SYMBOL 255

class LabeledMatrixLoader
{
public:
  static GSL::Matrix *load(Alphabet &,const AlphabetMap &,
			   const String &filename,double defaultValue=0);
  static void load(Alphabet &,const AlphabetMap &,const String &filename,
		   GSL::Matrix &,double defaultValue=0);
private:
  const AlphabetMap &alphabetMap;
  static Regex commentRegex, headerRegex, tableRegex, errorRegex;
};

}

#endif
