/****************************************************************
 Random.H
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Random_H
#define INCL_Random_H
#include <iostream>
#include <gsl/gsl_rng.h>
using namespace std;


namespace GSL {

    
class Random
{
public:
    // Initialization
    static void randomize();
    static void seed(unsigned int seed);

    // Uniformly distributed random numbers:
    static unsigned long int randomUnsignedLong(unsigned long int min,
                                                unsigned long int max);
    static unsigned int randomUnsigned(unsigned min,unsigned max);
    static int randomInt(int min,int max);
    static float randomFloat(float min,float max); // interval [min,max)
    static double randomDouble(double min,double max);//interval [min,max)

    // SEMI-PRIVATE (for use by specific distribution classes):
    static gsl_rng *getGenerator();
private:
    Random();
    static Random initializer;
    static gsl_rng *rng;
    static const gsl_rng_type *rngType;
};

}
#endif

