/***********************************************************************
 IndexedFasta.C
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#include "IndexedFasta.H"
#include <iostream>


BOOM::IndexedFasta::IndexedFasta(const BOOM::String &filename)
  : file(filename)
{
  // ctor
}



void BOOM::IndexedFasta::load(long begin,long len,char *buffer)
{
  file.seek(begin);
  file.read(len,(void*)buffer);
}



BOOM::String *BOOM::IndexedFasta::load(long begin,long len)
{
  char *buffer=new char[len+1];
  load(begin,len,buffer);
  buffer[len]='\0';
  BOOM::String *s=new BOOM::String(buffer);
  delete [] buffer;
  return s;
}



void BOOM::IndexedFasta::load(long begin,long len,BOOM::String &s)
{
  char *buffer=new char[len+1];
  load(begin,len,buffer);
  buffer[len]='\0';
  s=buffer;
  delete [] buffer;
}



long BOOM::IndexedFasta::getSize() const
{
  return file.getSize();
}


