/***********************************************************************
 InversionMatrix.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_InversionMatrix_H
#define INCL_BOOM_InversionMatrix_H
#include "DblMatrix.H"
using namespace std;

namespace BOOM {
class InversionMatrix : public BOOM::DblMatrix
{
public:
  InversionMatrix(int rows);
  virtual double &operator()(int row,int col);
  bool detectNonInvertible();
  virtual int getNumColumns();
  void getInverted(BOOM::DblMatrix &);
  void install(BOOM::DblMatrix &);
private:
  void setupIdentMatrix();
};
}

#endif
