/***********************************************************************
 Iterator.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_Iterator_H
#define INCL_BOOM_Iterator_H
using namespace std;

namespace BOOM {
template <class T>
class Iterator
{
public:
  virtual void operator++()=0;
  virtual void operator++(int)=0;
  virtual T &operator*()=0;
  virtual bool operator==(const BOOM::Iterator<T> &) const=0;
  virtual bool operator!=(const BOOM::Iterator<T> &i) const
    {return !(i==*this);}
  virtual BOOM::Iterator<T> &clone()=0;
};
}


#endif
