/***********************************************************************
 LinRegressor.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_LinRegressor_H
#define INCL_BOOM_LinRegressor_H
#include <utility>
#include "Vector.H"
#include "LinearFunc.H"
using namespace std;

namespace BOOM {
typedef pair<double,double> DblPoint;
typedef BOOM::Vector<DblPoint> DblPointVector;

class LinRegressor
{
public:
  LinearFunc regress(DblPointVector &);
  LinearFunc regress(BOOM::Vector<double> &);
private:
  LinearFunc compute(double sumX,double sumXX,double sumY,
			 double sumYY,double sumXY,int n);
};
}

#endif
