/***********************************************************************
 LinearFunc.C
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#include "LinearFunc.H"
using namespace std;



BOOM::LinearFunc::LinearFunc(double slope,
			       double intercept,
			       double coefOfDeterm)
  : slope(slope), intercept(intercept),
    coefOfDeterm(coefOfDeterm)
{
   
}



BOOM::LinearFunc::LinearFunc()
{
   
}



double BOOM::LinearFunc::operator()(double x) const
{
  return slope*x+intercept;
}



BOOM::LinearFunc &BOOM::LinearFunc::operator=(const BOOM::LinearFunc &f)
{
  slope=f.slope;
  intercept=f.intercept;
  coefOfDeterm=f.coefOfDeterm;
}



double BOOM::LinearFunc::getCoefDeterm() const
{
  return coefOfDeterm;
}
