/***********************************************************************
 MolecularSequenceType.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_MolecularSequenceType_H
#define INCL_MolecularSequenceType_H
#include <iostream>


namespace BOOM {

enum MolecularSequenceType
  {
    DNA,
    PROTEIN
  };
}
using namespace BOOM;


inline ostream &operator<<(ostream &os,BOOM::MolecularSequenceType t)
{
  switch(t)
    {
    case DNA: os<<"DNA"; break;
    case PROTEIN: os<<"PROTEIN"; break;
    }
  return os;
}


inline istream &operator>>(istream &is,BOOM::MolecularSequenceType &t)
{
  String s;
  is>>s;
  if(s=="DNA") t=DNA;
  else if(s=="PROTEIN") t=PROTEIN;
  else throw "Invalid MolecularSequenceType in operator>>";
  return is;
}

#endif
