/****************************************************************
 Mutex.C
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#include <iostream>
#include "Mutex.H"
using namespace std;
using namespace BOOM;

Mutex::Mutex()
{
    // ctor

    pthread_mutexattr_init(&attr);
    pthread_mutex_init(&mutex,&attr);
}



Mutex::~Mutex()
{
    // dtor

    pthread_mutex_destroy(&mutex);
    pthread_mutexattr_destroy(&attr);
}



void Mutex::wait()
{
    pthread_mutex_lock(&mutex);
}



void Mutex::signal()
{
    pthread_mutex_unlock(&mutex);
}


