/***********************************************************************
 NthOrderStringIterator.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_NthOrderStringIterator_H
#define INCL_NthOrderStringIterator_H
#include "Alphabet.H"
#include "Sequence.H"
#include "String.H"

// Generates strings of length N (not N+1!)

namespace BOOM {
class NthOrderStringIterator
{
  Alphabet &alphabet;
  int alphabetSize, N;
  Sequence current;
  bool hasMore;

  void advance();
public:
  NthOrderStringIterator(int N,Alphabet &);
  BOOM::String getNextString();
  BOOM::Sequence getNextSequence();
  void getNext(BOOM::Sequence &,BOOM::String &);
  bool done();
  void reset();
};
}

#endif
