/****************************************************************
 PrefixSumArrayFile.C
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#include <iostream>
#include "PrefixSumArrayFile.H"
using namespace std;
using namespace BOOM;


PrefixSumArrayFile::PrefixSumArrayFile(const String &filename)
  : file(filename,"r")
{
}



int PrefixSumArrayFile::getLength()
{
  return file.getSize()/sizeof(double);
}



double PrefixSumArrayFile::getLogLikelihood(long begin,long end) // half-open interval: [b,e)
{
  double beginValue;
  if(begin>0) {
    file.seek(begin-1);
    beginValue=file.readDouble();
  }
  else beginValue=0.0;
  file.seek(end-1);
  double endValue=file.readDouble();
  return endValue-beginValue;
}



void PrefixSumArrayFile::close()
{
  file.close();
}


