/****************************************************************
 PrefixSumArrayFile.H
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_PrefixSumArrayFile_H
#define INCL_PrefixSumArrayFile_H
#include <iostream>
#include "BOOM/File.H"
using namespace std;
using namespace BOOM;

// Implements a prefix-sum array on disk

class PrefixSumArrayFile
{
  File file;
public:
  PrefixSumArrayFile(const String &filename);
  int getLength();
  double getLogLikelihood(long begin,long end); // half-open interval: [b,e)
  void close();
};

#endif

