/***********************************************************************
 Random.C
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#include <time.h>
#include <stdlib.h>
#include <limits.h>
#include <iostream>
#include "Random.H"
using namespace std;
using namespace BOOM;


float BOOM::Random0to1()
{
  const int randInt=RandomNumber(LARGEST_RANDOM_NUMBER);

  return randInt/(float)(LARGEST_RANDOM_NUMBER-1);
}



float BOOM::RandomFloat(float from,float to)
{
  return RandomFloat(to-from)+from;
}



float BOOM::RandomFloat(float range)
{
  return Random0to1()*range;
}



float BOOM::RandomGaussian(float min,float max,int n)
{
  float sum=0.0;
  int i;
  for(i=0 ; i<n ; ++i)
    sum+=RandomFloat(min,max);
  return sum/n;
}



int BOOM::RandomNumber(int n)
{
  return n>1 ? rand() % n : 0;
}



unsigned BOOM::GetRandomSeed()
{
  randomize();  
  return unsigned(RandomNumber(INT_MAX));
}



void BOOM::SeedRandomizer(unsigned s)
{
  srand(s);
}



void BOOM::randomize()
{
  unsigned seed=(unsigned) time(0);
  srand(seed);
}
