/***********************************************************************
 Regex.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_Regex_H
#define INCL_BOOM_Regex_H
#include "String.H"
using namespace std;

extern "C" {
#include "regex.h"
}

namespace BOOM {
class Regex
{
public:
  Regex(const BOOM::String &regex);
  ~Regex();
  BOOM::String operator[](int whichSubexpression);  
  BOOM::String getEntireMatch();
  BOOM::String substitute(const BOOM::String &substrate,
			const BOOM::String &replacement);
  BOOM::Vector<BOOM::String*> *split(const BOOM::String &substrate);
  bool match(const BOOM::String &);
  bool search(const BOOM::String &);
  int getNumSubexpressions() const;
  static BOOM::String substitute(const BOOM::String &regex,
			       const BOOM::String &replacement,
			       const BOOM::String &substrate);
  static BOOM::Vector<BOOM::String*> *split(const BOOM::String &regex,
				    const BOOM::String &substrate);
  static bool match(const BOOM::String &regex,
		    const BOOM::String &substrate);
  static bool search(const BOOM::String &regex,
		     const BOOM::String &substrate);
  void getMatchIndices(int regNum,int &start,int &end);
private:
  re_registers reg;
  re_pattern_buffer patbuf;
  int numOfSubexpress;
  BOOM::String regex;
  const BOOM::String *substrate;
  BOOM::String preprocess(const BOOM::String &);
  void compile();
};
}

#endif
