/***********************************************************************
 SequenceEntropy.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_SequenceEntropy_H
#define INCL_BOOM_SequenceEntropy_H
#include "Sequence.H"
#include "String.H"

namespace BOOM {
class SequenceEntropy
{
public:
  static double entropy(const Sequence &,double &maxEntropy);
  static double entropy(const BOOM::String &,double &maxEntropy);
  static double jointEntropy(const Sequence &,int order,double &maxEntropy);
  static double jointEntropy(const BOOM::String &,int order,
			     double &maxEntropy);
  static double conditionalEntropy(const Sequence &,int order);
  static double conditionalEntropy(const BOOM::String &,int order);
};
}

#endif
