/***********************************************************************
 SparseGraph.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_SparseGraph_H
#define INCL_BOOM_SparseGraph_H
#include "Vector.H"
#include "Graph.H"
using namespace std;

namespace BOOM {

class SparseGraph : public Graph
{
public:
  SparseGraph(int numVertices=0);
  virtual Neighborhood *getNeighborsOf(VertexId,bool &shouldDelete) const;
  virtual VertexId addVertex();
  virtual bool areAdjacent(VertexId,VertexId) const;
  virtual int getDegree(VertexId) const;
  virtual int getNumEdges() const;
  virtual int getNumVertices() const;
  virtual void addEdge(VertexId from,VertexId to);
  virtual void removeEdge(VertexId from,VertexId to);
private:
  int numEdges;
  BOOM::Vector<Neighborhood> neighborhoods;
};
}

#endif
