/***********************************************************************
 SummaryStats.H
 bmajoros@tigr.org

 BOOM : Bioinformatics Object Oriented Modules

 This software is open source, and is distributed under the terms of the
 ARTISTIC LICENSE, as described at www.opensource.org.
 ***********************************************************************/
#ifndef INCL_BOOM_SummaryStats_H
#define INCL_BOOM_SummaryStats_H
#include "Vector.H"
using namespace std;

namespace BOOM {
class SummaryStats
{
public:
  SummaryStats(const BOOM::Vector<int> &);
  SummaryStats(const BOOM::Vector<float> &);
  SummaryStats(const BOOM::Vector<double> &);
  double getMax();
  double getMean();
  double getMin();
  double getStdDev();
  int getN();
private:
  int n;
  double mean, stddev, min, max;
  void compute(const BOOM::Vector<double> &);
  void compute(const BOOM::Vector<float> &);
  void compute(const BOOM::Vector<int> &);
};
}

#endif
