/****************************************************************
 DecisionTree.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_DecisionTree_H
#define INCL_DecisionTree_H

#include "TreeNode.H"
#include "BOOM/String.H"
#include "BOOM/Vector.H"
#include <iostream>

class DecisionTree
{
  TreeNode *root;

  static void dfs(TreeNode *,ostream &);
  static void dfs(TreeNode *,Vector<float> &);
public:
  DecisionTree(TreeNode *root);
  TreeNode *getRoot();
  void save(String filename);
  void load(String filename);
  void getEntropies(Vector<float> &);
};


#endif
