/****************************************************************
 CrossoverPoint.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "CrossoverPoint.H"
#include <iostream>
using namespace std;


CrossoverPoint::CrossoverPoint()
{
  // default ctor
}



CrossoverPoint::CrossoverPoint(const CrossoverPoint &other)
  : parent(other.parent), childNum(other.childNum),
    depth(other.depth)
{
  // copy ctor
}



CrossoverPoint::CrossoverPoint(TreeNode *parent,int childNum,int depth)
  : parent(parent), childNum(childNum), depth(depth)
{
  // ctor
}



CrossoverPoint &CrossoverPoint::operator=(const CrossoverPoint &other)
{
  parent=other.parent;
  childNum=other.childNum;
}



TreeNode *CrossoverPoint::getParent() const
{
  return parent;
}



int CrossoverPoint::getChildNum() const
{
  return childNum;
}



int CrossoverPoint::getDepth() const
{
  return depth;
}



void CrossoverPoint::performCrossover(CrossoverPoint *other)
{
  TreeNode *myChild=parent->getIthChild(childNum);
  TreeNode *herChild=other->parent->getIthChild(other->childNum);
  
  parent->setIthChild(childNum,herChild);
  other->parent->setIthChild(other->childNum,myChild);
}


