/****************************************************************
 Population.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Population.H"
#include <iostream>
using namespace std;


Population::Population()
{
  // ctor
}



Population::~Population()
{
  // dtor

  int i, n=members.size();
  for(i=0 ; i<n ; ++i)
    delete members[i];
}



void Population::addMember(Individual *ind)
{
  members.push_back(ind);
}



int Population::size()
{
  return members.size();
}



Individual *Population::getMember(int i)
{
  return members[i];
}



int Population::getBestIndex()
{
  float bestFitness;
  int bestIndex=-1;

  int i, n=members.size();
  for(i=0 ; i<n ; ++i)
    {
      Individual *ind=members[i];
      if(bestIndex<0 ||
	 ind->getNormalizedFitness()>bestFitness)
	{
	  bestFitness=ind->getNormalizedFitness();
	  bestIndex=i;
	}
    }

  return bestIndex;
}



Individual *Population::getMostFit()
{
  return members[getBestIndex()];
}



Individual *Population::removeMostFit()
{
  int bestIndex=getBestIndex();
  Individual *bestIndividual=members[bestIndex];
  members[bestIndex]=NULL;
  return bestIndividual;
}



void Population::printOn(ostream &os) const
{
  int i, n=members.size();
  for(i=0 ; i<n ; ++i)
    {
      os << "---------------------------------------------------------------------\n";
      os << "#" << i << *members[i] << endl;
    }
      os << "---------------------------------------------------------------------\n";
}



ostream &operator<<(ostream &os,const Population &population)
{
  population.printOn(os);
  return os;
}

