/****************************************************************
 RouletteWheel.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_RouletteWheel_H
#define INCL_RouletteWheel_H

#include "BOOM/Array1D.H"
#include "Population.H"
using namespace BOOM;



// **************************************************
//                class RouletteWheel
// **************************************************

class RouletteWheel
{
  FloatArray1D array;
  int lookup(float);
  void initializeSectors(Population &);
  void initializeSectors(vector<Individual*> &,int vectorSize);
public:
  RouletteWheel(Population &);
  RouletteWheel(vector<Individual*> &,int vectorSize);
  int spin();
};

#endif
