/****************************************************************
 Tournament.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Tournament.H"
#include "BOOM/Random.H"
using namespace BOOM;


Tournament::Tournament(Population &population,int size)
  : v(size)
{
  int i;
  for(i=0 ; i<size ; ++i)
    {
      const int index=RandomNumber(population.size());
      v[i]=population.getMember(index);
    }

  wheel=new RouletteWheel(v,size);
}



Tournament::~Tournament()
{
  // dtor

  delete wheel;
}



Individual *Tournament::pickWinner()
{
  return v[wheel->spin()];
}


