/****************************************************************
 Discriminant.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Discriminant_H
#define INCL_Discriminant_H
#include <iostream>
#include "BOOM/GSL/Vector.H"
#include "../common/Case.H"
using namespace std;
using namespace BOOM;


/****************************************************************
 A Discriminant is a set of coefficients.  It can be used to 
 form a linear combination of the variables in a test case,
 producing a single scalar value.
 ****************************************************************/
class Discriminant
{
public:
  Discriminant() {}
  Discriminant(GSL::Vector &eigenvector,double eigenvalue=0);
  double operator()(const Case &) const;
  double getEigenvalue() const;
  void printOn(ostream &) const;
  void readFrom(istream &);
private:
  GSL::Vector eigenvector;
  double eigenvalue;
};

ostream &operator<<(ostream &,const Discriminant &);
istream &operator>>(istream &,Discriminant &);

#endif

