/****************************************************************
 Model.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Model_H
#define INCL_Model_H
#include <iostream>
#include "Discriminant.H"
#include "BOOM/Vector.H"
#include "BOOM/GSL/Vector.H"
#include "../common/Case.H"
using namespace std;
using namespace BOOM;


/****************************************************************
 A Model is a set of Discriminants.  It can be used to map a
 training/test case to an N-dimensional point, where N is the
 number of Discriminants.
 ****************************************************************/
class Model
{
public:
  virtual ~Model();
  void addDiscriminant(Discriminant *);
  int getDim() const;
  GSL::Vector *operator()(const Case &) const;
  void mapToPoint(const Case &,GSL::Vector &result) const;
  void printOn(ostream &) const;
  void readFrom(istream &);
private:
  BOOM::Vector<Discriminant*> discriminants;
};

ostream &operator<<(ostream &,const Model &);
istream &operator>>(istream &,Model &);

#endif

