/****************************************************************
 IndividualSchema.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_IndividualSchema_H
#define INCL_IndividualSchema_H

#include "BOOM/Vector.H"
using namespace BOOM;


class IndividualSchema
{
  Vector<int> adfs;
  Vector<int> entryPoints;
  //bool recursionAllowed;
  int maxCallCount;
  static IndividualSchema *global;

  IndividualSchema(/*bool recursionAllowed,*/int maxCallCount);
public:
  static void allocateGlobal(int maxCallCount);
  static IndividualSchema &getGlobal();
  void addADF(int numParms);
  void addEntryPoint(int numParms);
  int getNumADFs();
  int getNumEntryPoints();
  int getADFarity(int i);
  int getEntryPointArity(int i);
  //bool isRecursionAllowed();
  int getMaxCallCount();
};


#endif
