/****************************************************************
 Population.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Population_H
#define INCL_Population_H

#include "Individual.H"
#include "BOOM/Vector.H"
#include <iostream>
using namespace std;
using namespace BOOM;


class Population
{
  Vector<Individual *> members;
  
  int getBestIndex();
public:
  Population();
  virtual ~Population(); // deletes members
  void addMember(Individual *);
  int size();
  Individual *getMember(int);
  Individual *getMostFit();
  Individual *removeMostFit();
  void printOn(ostream &) const;
};

ostream &operator<<(ostream &,const Population &);

#endif
