/****************************************************************
 PopulationBuilder.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "PopulationBuilder.H"
#include <iostream>
using namespace std;


PopulationBuilder::PopulationBuilder(SymbolSet &symbolSet)
  : individualBuilder(symbolSet)
{
  // ctor
}



Population *PopulationBuilder::buildPopulation(int populationSize,
					       int minHeight,
					       int maxHeight)
{
  Population *population=new Population();

  int numHeights=maxHeight-minHeight+1;
  int numPerHeight=int(populationSize/float(numHeights)+1);

  int i, height=minHeight, numAtHeight=0;
  for(i=0 ; i<populationSize ; ++i)
    {
      Individual *individual=individualBuilder.buildIndividual(height);
      population->addMember(individual);

      ++numAtHeight;
      if(numAtHeight==numPerHeight)
	{
	  ++height;
	  numAtHeight=0;
	}
    }

  return population;
}



