/****************************************************************
 SymbolSet.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "SymbolSet.H"
#include <iostream>
#include "BOOM/Random.H"
using namespace std;
using namespace BOOM;


SymbolSet::SymbolSet()
{
  // ctor
}



void SymbolSet::addNonterminal(TreeNode *node)
{
  nonterminals.push_back(node);
}



void SymbolSet::addTerminal(TreeNode *node)
{
  terminals.push_back(node);
}



Vector<TreeNode*> &SymbolSet::getNonterminals()
{
  return nonterminals;
}



Vector<TreeNode*> &SymbolSet::getTerminals()
{
  return terminals;
}






TreeNode *SymbolSet::randomTerminal()
{
  return terminals[RandomNumber(terminals.size())]->instantiate();
}



TreeNode *SymbolSet::randomNonterminal()
{
  return nonterminals[RandomNumber(nonterminals.size())]->instantiate();
}
