/****************************************************************
 Tableau.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Tableau.H"
#include <iostream>
#include <stdlib.h>
using namespace std;


Tableau *Tableau::global;


Tableau::Tableau(ConfigFile &config)
{
  // ctor

  Pm=config.getFloatOrDie("point-mutation");
  subtreeMutation=config.getFloatOrDie("subtree-mutation");
  minConst=config.getFloatOrDie("min-const");
  maxConst=config.getFloatOrDie("max-const");
  initialHeight=config.getIntOrDie("initial-tree-height");
  maxHeight=config.getIntOrDie("max-tree-height");
  seed=config.getIntOrDie("seed");
  nonterminals=config.lookupOrDie("nonterminals");
  terminals=config.lookupOrDie("terminals");
  trainPortion=config.getFloatOrDie("percent-training-set");
  initialTemperature=config.getFloatOrDie("initial-temperature");
  finalTemperature=config.getFloatOrDie("final-temperature");
  temperatureDecay=config.getFloatOrDie("temperature-decay");
  K=config.getFloatOrDie("K");
}



void Tableau::processConfig(ConfigFile &config)
{
  global=new Tableau(config);
}



Tableau &Tableau::getGlobal()
{
  return *global;
}



