/****************************************************************
 Discretizer.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Discretizer_H
#define INCL_Discretizer_H
#include <iostream>
#include "../common/Case.H"
using namespace std;

class Discretizer // sort of like an Appetizer, but more discrete...
{
  float minValue, maxValue, bucketSize;
  int numBuckets;
public:
  Discretizer() {}
  Discretizer(istream &);
  Discretizer(float minValue,float maxValue,float bucketSize,
	      int numBuckets);
  int discretize(float value);
  void printOn(ostream &);
  void load(istream &);
  int getNumBuckets() const;
  float getMinValue() const;
  float getMaxValue() const;
  float getBucketSize() const;
  static int getDiscrete(Case &c,int attr,Discretizer *);
};

ostream &operator<<(ostream &,Discretizer &);
istream &operator>>(istream &,Discretizer &);

#endif
