/****************************************************************
 Discretizer.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Discretizer.H"


Discretizer::Discretizer(istream &is)
{
  // ctor

  load(is);
}



Discretizer::Discretizer(float minValue,float bucketSize)
  : minValue(minValue), bucketSize(bucketSize)
{
  // ctor
}



int Discretizer::discretize(float value)
{
  return int((value-minValue)/bucketSize);
}



void Discretizer::load(istream &is)
{
  is>>minValue>>bucketSize;
}



void Discretizer::printOn(ostream &os)
{
  os<<minValue<<"\t"<<bucketSize<<endl;
}



ostream &operator<<(ostream &os,Discretizer &d)
{
  d.printOn(os);
  return os;
}


