/****************************************************************
 Model.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Model_H
#define INCL_Model_H

#include "PublicModel.H"
#include "../common/Case.H"
#include "../common/Schema.H"
#include "BOOM/String.H"
using namespace BOOM;

class Model
{
  PublicModel &publicModel;
  Schema &schema;

  float P_xi_given_y(int categoryIndex,Case &);
  float P_y_given_xi(Case &,int categoryIndex);
  float P_xi(int category);
public:
  Model(PublicModel &,Schema &);
  int operator()(Case &);// returns category
  void save(const String &filename);
  static Model *load(const String &filename,Schema &s);
};

#endif
