/****************************************************************
 ModelBuilder.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_ModelBuilder_H
#define INCL_ModelBuilder_H

#include "Model.H"
#include "DataSetStatistics.H"
#include "../common/Schema.H"
#include "../common/TrainingCase.H"
#include "../common/TrainingSet.H"
using namespace BOOM;

class ModelBuilder
{
  TrainingSet &dataSet;
  DataSetStatistics dataSetStats;
  int numCategories;
  int numPredictors;
  Schema &schema;

  PublicModel *buildPublicModel();
  void allocateDiscretizers(PublicModel *);
  void processTrainingCases(PublicModel *);
  void processPredictors(TrainingCase &,PublicModel *,int categoryIndex);
  void divideYStructure(PublicModel *);
  void divideCategoriesBy(PublicModel *,int numCases);
public:
  ModelBuilder(TrainingSet &,Schema &);
  Model *buildModel();
};

#endif
