/****************************************************************
 PublicModel.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_PublicModel_H
#define INCL_PublicModel_H

#include "BOOM/Map.H"
#include "BOOM/Array1D.H"
#include "BOOM/String.H"
#include "YStructure.H"
using namespace BOOM;

struct PublicModel
{
  YStructure yStructure;
  FloatArray1D xProportions;
  Map<int,int> &x2index;
  Map<int,int> index2x;

  PublicModel(int numPredictors,int numCategories,
	      Map<int,int> &x2Index);
  PublicModel(const String &filename);
  void save(const String &filename);
  void load(const String &filename);
};

#endif
