/****************************************************************
 YStructure.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_YStructure_H
#define INCL_YStructure_H

#include "BOOM/Array1D.H"
#include "YStructureElement.H"
#include <iostream>
using namespace BOOM;

class YStructure
{
  Array1D<YStructureElement*> array; // indexed by predictor variable
  int numCategories;
public:
  YStructure() {}
  YStructure(int numPredictors,int numCategories);
  float &lookup(int whichPredictor,int predictorValue,
		int categoryIndex);
  void allocateDiscretizer(int whichPredictor,float minValue,
			   float bucketSize);
  YStructureElement &operator[](int);
  int getNumPredictors() const;
  void load(istream &);
  void save(ostream &);
};

#endif
