/****************************************************************
 YStructureElement.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_YStructureElement_H
#define INCL_YStructureElement_H

#include "BOOM/Map.H"
#include "BOOM/Array1D.H"
#include "Discretizer.H"
#include <iostream>
using namespace BOOM;

/****************************************************************
 This computes P(Xi|Y) for a single predictor variable Xi.
 ****************************************************************/
class YStructureElement
{
  Map<int,FloatArray1D*> assocArray;
  Discretizer *discretizer;
  int numCategories;
  
  void load(istream &);
public:
  YStructureElement(int numCategories);
  YStructureElement(istream &);
  float &probability(int predictorValue,int categoryIndex); //P(Xi|Y)
  Discretizer &getDiscretizer();//throws exception
  void allocateDiscretizer(float minValue,float bucketSize);
  Map<int,FloatArray1D*>::iterator getIterator();
  Map<int,FloatArray1D*>::iterator getIteratorEnd();
  void printOn(ostream &);
};


ostream &operator<<(ostream &,YStructureElement &);

#endif
