/****************************************************************
 AttrValuePair.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "AttrValuePair.H"
#include <iostream>



AttrValuePair::AttrValuePair(int attribute,double value)
  : attribute(attribute), value(value)
{
  // ctor
}



AttrValuePair::AttrValuePair(int attribute,int value)
  : attribute(attribute), value((double) value)
{
  // ctor
}



int AttrValuePair::getAttribute()
{
  return attribute;
}



double AttrValuePair::getFloatValue()
{
  return value;
}



int AttrValuePair::getIntValue()
{
  return (int) value;
}


void AttrValuePair::printOn(ostream &os)
{
  os<<"("<<attribute<<","<<value<<")";
}



ostream &operator<<(ostream &os,AttrValuePair &p)
{
  p.printOn(os);
  return os;
}


