/****************************************************************
 Case.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Case.H"
#include <iostream>
using namespace BOOM;


Case::Case(int numAttributes)
  : array(numAttributes)
{
  // ctor
}



double Case::getContinuous(int attrNum) const
{
  return array[attrNum];
}



int Case::getDiscrete(int attrNum) const
{
  return int(array[attrNum]);
}



void Case::setContinuous(int attrNum,double f)
{
  array[attrNum]=f;
}



void Case::setDiscrete(int attrNum,int x)
{
  array[attrNum]=double(x);
}



int Case::getNumAttributes() const
{
  return array.size();
}



void Case::printOn(ostream &os)
{
  int i, n=array.size();
  for(i=0 ; i<n ; ++i)
    os << array[i] << ' ';
}



ostream &operator<<(ostream &os,const Case &c)
{
  ((Case &)c).printOn(os);
  return os;
}



void Case::resize(int newSize)
{
  array.resize(newSize);
}


