/****************************************************************
 Case.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Case_H
#define INCL_Case_H
#include "BOOM/Array1D.H"
#include <iostream>
using namespace BOOM;

class Case
{
  Array1D<double> array;
public:
  Case(int numAttributes);
  double getContinuous(int attrNum) const;
  int getDiscrete(int attrNum) const;
  void setContinuous(int attrNum,double);
  void setDiscrete(int attrNum,int);
  int getNumAttributes() const;
  virtual void printOn(ostream &);
  void resize(int newSize);
};

ostream &operator<<(ostream &,const Case &);

#endif
