/****************************************************************
 Distribution.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Distribution.H"
#include <iostream>
using namespace BOOM;


Distribution::Distribution(int numCategories)
  : array(numCategories)
{
  // ctor
}



float &Distribution::operator[](int i)
{
  return array[i];
}



int Distribution::getNumCategories()
{
  return array.size();
}



void Distribution::setAllTo(float f)
{
  array.setAllTo(f);
}



int Distribution::mostPopularCategory()
{
  int mostPopular=0;
  float highestP=0.0;
  int i, n=getNumCategories();
  for(i=0 ; i<n ; ++i)
    {
      float p=array[i];
      if(p>highestP)
	{
	  mostPopular=i;
	  highestP=p;
	}
    }

  return mostPopular;  
}





