/****************************************************************
 Entropy.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Entropy.H"
#include <math.h>
#include <iostream>
using namespace BOOM;

static float logof2=log(2.0);


float binaryLog(float x)
{
  return log(x)/logof2;
}



float entropy(Distribution &distribution)
{
  // -sum p log p

  float sum=0.0;

  int n=distribution.getNumCategories();
  for(int i=0 ; i<n ; ++i)
    {
      float p=distribution[i];
      if(p>0.0)
	sum+=p * binaryLog(p);
    }

  float H=-sum;
  return H;
}




