/****************************************************************
 Schema.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Schema_H
#define INCL_Schema_H
#include "TypeDescriptor.H"
#include "BOOM/Vector.H"
#include "BOOM/Map.H"
#include <iostream>
using namespace BOOM;


class TrainingSet;

class Schema
{
  int numCategories;
  Vector<TypeDescriptor*> v;
  Map<int,int> *maps;
public:
  Schema(int numCategories);
  void add(TypeDescriptor *);
  int numAttributes();
  TypeDescriptor *operator[](int);
  int getNumCategories();
  void removeAttribute(int);
  Map<int,int> *countDiscrete(TrainingSet &);
  void printOn(ostream &) const;
};

ostream &operator<<(ostream &,const Schema &);

#endif
