/****************************************************************
 TrainingSet.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_TrainingSet_H
#define INCL_TrainingSet_H
#include "Schema.H"
#include "BOOM/Vector.H"
#include "BOOM/String.H"
#include "TrainingCase.H"
using namespace BOOM;

class TrainingSet
{
  Schema &schema;
  Vector<TrainingCase *> theVector;

  void load(String &filename,bool requireCategory);
public:
  TrainingSet(Schema &,String filename,bool requireCategory=true);
  TrainingSet(Schema &);
  TrainingCase &getCase(int i);
  int numCases();
  Schema &getSchema();
  TrainingSet *getCategory(int category);
  TrainingSet *getNotCategory(int category);
  void splitByCategory(Array1D<TrainingSet*> &);
  void addCase(TrainingCase *);
  void deleteCases();
};


#endif
