/****************************************************************
 TypeDescriptor.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "TypeDescriptor.H"
#include <iostream>
using namespace BOOM;


ostream &operator<<(ostream &os,const TypeDescriptor &d)
{
  d.printOn(os);
  return os;
}



TypeDescriptor::TypeDescriptor(DescriptorType t,String name)
  : type(t), name(name)
{
  // ctor
}



DescriptorType TypeDescriptor::getType() const
{
  return type;
}



String TypeDescriptor::getName() const
{
  return name;
}



Discrete::Discrete(int n,String name)
  : TypeDescriptor(DISCRETE,name), n(n)
{
  // ctor
}



int Discrete::getN()
{
  return n;
}



void Discrete::setN(int newN)
{
  n=newN;
}



void Discrete::printOn(ostream &os) const
{
  os << getName().c_str() << ": discrete";
}



Continuous::Continuous(String name)
  : TypeDescriptor(CONTINUOUS,name)
{
  // ctor
}



void Continuous::printOn(ostream &os) const
{
  os << getName().c_str() << ": continuous";
}


