/****************************************************************
 TypeDescriptor.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_TypeDescriptor_H
#define INCL_TypeDescriptor_H
#include <iostream>
#include "BOOM/String.H"
using namespace BOOM;

enum DescriptorType
{
  DISCRETE,
  CONTINUOUS
};

class TypeDescriptor
{
  String name;
  DescriptorType type;
public:
  TypeDescriptor(DescriptorType,String name);
  DescriptorType getType() const;
  String getName() const;
  virtual void printOn(ostream &) const=0;
};

ostream &operator<<(ostream &,const TypeDescriptor &);

class Discrete : public TypeDescriptor
{
  int n; // number of distinct values this variable can assume
public:
  Discrete(int,String name);
  void setN(int);
  int getN();
  virtual void printOn(ostream &) const;
};

class Continuous : public TypeDescriptor
{
public:
  Continuous(String name);
  virtual void printOn(ostream &) const;
};

#endif
