/****************************************************************
 LogLikelihood.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_LogLikelihood_H
#define INCL_LogLikelihood_H
#include <iostream>
#include "BOOM/GSL/Optimizer.H"
#include "../common/TrainingSet.H"
#include "LogisticFunction.H"
using namespace std;
using namespace BOOM;


struct LogLikelihood : public GSL::ObjectiveFunction
{
  LogLikelihood(TrainingSet &positives,TrainingSet &negatives);
  virtual double f(const GSL::Vector &currentPoint);
  virtual void gradient(const GSL::Vector &currentPoint,
			GSL::Vector &gradient);
  void initFunc(LogisticFunction &,const GSL::Vector &currentPoint);
  bool isOK() {return ok;}
  void resetOK() {ok=true;}
private:
  TrainingSet &positives, &negatives;
  int numPos, numNeg, numAttributes;
  LogisticFunction func;
  bool ok;
  inline double sqr(double d) {return d*d;}
};


#endif

