/****************************************************************
 LogisticFunction.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include <iostream>
#include "LogisticFunction.H"
using namespace std;
using namespace BOOM;


LogisticFunction::LogisticFunction(int numAttributes)
  : b(numAttributes)
{
}



LogisticFunction::LogisticFunction(istream &is)
{
  readFrom(is);
}



double &LogisticFunction::getA()
{
  return a;
}



double &LogisticFunction::getB(int index)
{
  return b[index];
}



void LogisticFunction::printOn(ostream &os)
{
  os<<a<<endl<<b<<endl;
}



void LogisticFunction::readFrom(istream &is)
{
  is>>a>>b;
}



ostream &operator<<(ostream &os,LogisticFunction &f)
{
  f.printOn(os);
  return os;
}



double LogisticFunction::operator()(const Case &c)
{
  return 1.0/(1.0+lambda(c));
}


istream &operator>>(istream &is,LogisticFunction &f)
{
  f.readFrom(is);
  return is;
}





