#!/usr/bin/perl
use strict;
use ProgramName;

# Process the command line
my $name=ProgramName::get();
die "$name <in.names> <in.train> <in.test> <out.names> <out.train> <out.test>\n" unless @ARGV==6;
my ($inNames,$inTrain,$inTest,$outNames,$outTrain,$outTest)=@ARGV;

# Process the *.names file
open(IN,$inNames) || die "can't open $inNames\n";
open(OUT,">$outNames") || die "can't create file: $outNames\n";
my $firstLine=<IN>;
print OUT $firstLine;
my @attributes;
while(<IN>)
  {
    if(/(\S+):\s*\S+/)
      {
	my $name=$1;
	print OUT;
	push @attributes,$name;
      }
  }
my $n=@attributes;
for(my $i=0 ; $i<$n ; ++$i)
  {
    my $name1=$attributes[$i];
    for(my $j=$i ; $j<$n ; ++$j)
      {
	my $name2=$attributes[$j];
	print OUT "$name1\_x_$name2: continuous\n";
      }
  }
close(OUT);
close(IN);

# Process the data files
processData($inTrain,$outTrain);
processData($inTest,$outTest);



sub processData
  {
    my ($oldFile,$newFile)=@_;
    open(IN,$oldFile) || die "can't open $oldFile\n";
    open(OUT,">$newFile") || die "can't create file: $newFile\n";
    while(<IN>)
      {
	next unless $_=~/\S/;
	my @fields=split/\s+/,$_;
	my $n=@fields-1;
	for(my $i=0 ; $i<$n ; ++$i)
	  {print OUT "$fields[$i]\t"}
	for(my $i=0 ; $i<$n ; ++$i)
	  {
	    my $val1=$fields[$i];
	    for(my $j=$i ; $j<$n ; ++$j)
	      {
		my $val2=$fields[$j];
		my $newVal=$val1*$val2;
		print OUT "$newVal\t";
	      }
	  }
	my $cat=$fields[$n];
	print OUT "$cat\n";
      }
    close(OUT);
    close(IN);
  }



