/****************************************************************
 Normalizer.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Normalizer_H
#define INCL_Normalizer_H

#include <iostream>
#include "BOOM/Vector.H"
#include "NeuralCase.H"
using namespace std;
using namespace BOOM;

class Normalizer
{
  int numInputs, numOutputs;
  DoubleVector maxInput, maxOutput;
  DoubleVector minInput, minOutput;

  void findMaxima(Vector<NeuralCase*> &);
  void findMinima(Vector<NeuralCase*> &);
  void adjust(float factor,DoubleVector &,int n);
public:
  Normalizer(int numInputs=0,int numOutputs=0);
  void normalize(Vector<NeuralCase*> &);  // during deployment
  void normalize(Vector<NeuralCase*> &,   // during training
		 float maxAdjuster,float minAdjuster);
  void normalize(NeuralCase *);           // deployment or training
  float denormalizeOutput(float value,int outputIndex);
  void printOn(ostream &);
  void readFrom(istream &);
};

ostream &operator<<(ostream &,Normalizer &);
istream &operator>>(istream &,Normalizer &);

#endif
