/****************************************************************
 SigmaFunction.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "SigmaFunction.H"
#include "Neuron.H"
#include "NeuralNetwork.H"
#include "BOOM/Exceptions.H"
#include <iostream>
using namespace std;

float SigmaFunction::operator()(Neuron &neuron,NeuralNetwork &network)
{
  float sigma=0.0;
  
  const int num=neuron.getInDegree();
  int i;
  for(i=0 ; i<num ; ++i)
    {
      Synapse &synapse=neuron.getInput(i);
      const float weight=synapse.getWeight();
      const int index=synapse.getFrom();
      const float value=network[index].getActivationValue();
      const float product=weight*value;
      sigma+=product;
    }
  
  return sigma;
}

