/****************************************************************
 IndividualBuilder.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "IndividualBuilder.H"
#include <iostream>
#include "IndividualSchema.H"
using namespace std;


IndividualBuilder::IndividualBuilder(SymbolSet &symbolSet)
  : treeBuilder(symbolSet)
{
  // ctor
}



Individual *IndividualBuilder::buildIndividual(int treeHeight)
{
  Individual *individual=new Individual();

  IndividualSchema &schema=IndividualSchema::getGlobal();
  
  // Generate ADF's
  int i, n=schema.getNumADFs();
  for(i=0 ; i<n ; ++i)
    individual->getADF(i)=treeBuilder.buildTree(treeHeight);

  // Generate entry point(s):
  n=schema.getNumEntryPoints();
  for(i=0 ; i<n ; ++i)
    individual->getEntryPoint(i)=treeBuilder.buildTree(treeHeight);

  return individual;
}



TreeBuilder &IndividualBuilder::getTreeBuilder()
{
  return treeBuilder;
}


