/****************************************************************
 IndividualSchema.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "IndividualSchema.H"
#include <iostream>
#include "BOOM/String.H"
using namespace std;
using namespace BOOM;


IndividualSchema *IndividualSchema::global;



IndividualSchema::IndividualSchema(int maxCallCount)
  : maxCallCount(maxCallCount)
{
  // ctor
}



void IndividualSchema::addADF(int numParms)
{
  adfs.push_back(numParms);
}



void IndividualSchema::addEntryPoint(int numParms)
{
  entryPoints.push_back(numParms);
}



int IndividualSchema::getNumADFs()
{
  return adfs.size();
}



int IndividualSchema::getNumEntryPoints()
{
  return entryPoints.size();
}



int IndividualSchema::getADFarity(int i)
{
  return adfs[i];
}



int IndividualSchema::getEntryPointArity(int i)
{
  return entryPoints[i];
}



int IndividualSchema::getMaxCallCount()
{
  return maxCallCount;
}



void IndividualSchema::allocateGlobal(int maxCallCount)
{
  global=new IndividualSchema(maxCallCount);
}



IndividualSchema &IndividualSchema::getGlobal()
{
#ifdef DEBUG
  if(!global) 
    throw "IndividualSchema::getGlobal() called before global object has been allocated";
#endif

  return *global;
}


