/****************************************************************
 Tableau.H
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Tableau_H
#define INCL_Tableau_H

#include "BOOM/ConfigFile.H"
using namespace BOOM;

class Tableau
{
  static Tableau *global;
  float minConst; // min value of a constant node
  float maxConst; // max value of a constant node
  int maxHeight; // max height for any tree, any population
  String nonterminals; // comma-sep. list of nonterminals (operators)
  String terminals; // comma-sep. list of terminals (leaves)

  Tableau(ConfigFile &);
public:
  static void processConfig(ConfigFile &);
  static Tableau &getGlobal();
  float getMinConst() {return minConst;}
  float getMaxConst() {return maxConst;}
  int getMaxHeight() {return maxHeight;}
  String getNonterminals() {return nonterminals;}
  String getTerminals() {return terminals;}
};


#endif
