/****************************************************************
 TreeBuilder.C
 william.majoros@duke.edu

 Copyright 2005 William H. Majoros.  This is open-source software,
 governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "TreeBuilder.H"
#include <iostream>
#include "BOOM/Random.H"
using namespace std;
using namespace BOOM;


TreeBuilder::TreeBuilder(SymbolSet &symbolSet)
  : symbolSet(symbolSet)
{
  // ctor
}



TreeNode *TreeBuilder::buildTree(int height)
{
  switch(height)
    {
    case 0:
      return NULL;
    case 1:
      return symbolSet.randomTerminal();
    }

  TreeNode *root=symbolSet.randomNonterminal();
  int i, n=root->getArity();
  for(i=0 ; i<n ; ++i)
    {
      TreeNode *child=buildTree(height-1);
      root->addChild(child);
    }

  return root;
}



