/****************************************************************
 Discriminator.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Discriminator.H"
#include <iostream>
using namespace std;


Discriminator::Discriminator(DblMatrix &A)
  : A(A)
{
  // ctor
}



int Discriminator::operator()(Case &x)
{
  double value=0;

  int i, n=x.getNumAttributes();
  for(i=0 ; i<n ; ++i)
    value+=A(i,0)*x.getContinuous(i);
  value+=A(n,0); // Add the y-intercept

  return value<0.5 ? 0 : 1;
}



void Discriminator::printOn(ostream &os) const
{
  int n=A.getNumRows();
  for(int i=0 ; i<n ; ++i)
    {
      os<<A(i,0);
      if(i+1<n) os<<"*x"<<i<<" + ";
    }
}



ostream &operator<<(ostream &os,const Discriminator &d)
{
  d.printOn(os);
  return os;
}



