#!/usr/bin/perl
use strict;
use ProgramName;

my $name=ProgramName::get();
die "
$name <vars> <in.names> <out.names> [<in.data> <out.data> ...]
   where:
      <vars> is a comma-separated list of zero-based variable indices
             (e.g., 1,2,4,7,8)

"
  unless @ARGV>=3 && @ARGV%2==1;
my $list=shift @ARGV;
my $inNames=shift @ARGV;
my $outNames=shift @ARGV;
my @list=split/,/,$list;
my %keep;
foreach my $x (@list) {$keep{$x}=1}
my $totalVars;

processNamesFile($inNames,$outNames);
while(@ARGV>0)
  {
    my $infile=shift @ARGV;
    my $outfile=shift @ARGV;
    processDataFile($infile,$outfile);
  }


#====================================================================
sub processNamesFile
  {
    my ($infile,$outfile)=@_;
    open(IN,$infile) || die "can't open $infile\n";
    open(OUT,">$outfile") || die "can't create file: $outfile\n";
    my $line=<IN>;
    print OUT $line;
    my $index=0;
    while(<IN>)
      {
	if(/\S+/)
	  {
	    if($keep{$index}) {print OUT}
	    ++$index;
	  }
      }
    close(OUT);
    close(IN);
    $totalVars=$index;
  }

sub processDataFile
  {
    my ($infile,$outfile)=@_;
    open(IN,$infile) || die "can't open $infile\n";
    open(OUT,">$outfile") || die "can't create file: $outfile\n";
    while(<IN>)
      {
	if(/\S+/)
	  {
	    my @fields=split/\s+/,$_;
	    foreach my $i (@list)
	      {
		my $x=$fields[$i];
		print OUT "$x\t";
	      }
	    my $cat;
	    if(@fields>$totalVars) # if category is present...
	      {$cat=$fields[@fields-1]}
	    print OUT "$cat\n";
	  }
      }
    close(OUT);
    close(IN);
  }
